###########################################################################
# $Id: CachePage.p,v 1.5 2007-05-18 17:58:31 misha Exp $
###########################################################################

@CLASS
CachePage



###########################################################################
@auto[]
$tHeaderDefault[^table::create{name
charset
content-type
last-modified
expires
location
refresh
status
pragma
cache-control
}]

$hConst[
	$.hSeparator[
		$.sFields[|]
		$.sHeaders[-&-]
	]
	$.hBracket[
		$.sBegin[<!--headers--]
		$.sEnd[--headers-->]
	]
]
#end @auto[]



###########################################################################
@create[hParam]
$hParam[^hash::create[$hParam]]
$self.sCacheDir[^if(def $hParam.sCacheDir){$hParam.sCacheDir}{$hParam.cache_dir}]
$self.tHeader[^if(def $hParam.tHeader){$hParam.tHeader}{^if(def $hParam.headers){$hParam.headers}{$tHeaderDefault}}]
$self.bAddComments(^hParam.bAddComments.int(0))
#end @create[]



###########################################################################
# $iTime in secs
@run[sKey;iTime;jBody;jErrorHandler][bExecuted;sBody]
$result[^cache[$sCacheDir/$sKey]($iTime){$bExecuted(1)$sBody[$jBody]^sBody.trim[]^self._save($iTime)}{$caller.exception[$exception]$jErrorHandler}]

$result[^self._cut[$result]^self._comments[$sKey]($iTime;$bExecuted)]
#end @run[]



###########################################################################
# print filled headers as string
@_save[iTime][hFilled]
$result[]
^if($iTime){
	$hFilled[^hash::create[]]
	^tHeader.menu{
		^if(def $response:[$tHeader.name]){
			$hFilled.[$tHeader.name][$response:[$tHeader.name]]
		}
	}
	^if($hFilled){
		$result[$hConst.hBracket.sBegin^self._packHeaders[$hFilled]$hConst.hBracket.sEnd]
	}
}
#end @_save[]



###########################################################################
# cut comment with headers from text
@_cut[sBody]
^if(def $sBody && ^sBody.pos[$hConst.hBracket.sBegin] >= 0 && ^sBody.pos[$hConst.hBracket.sEnd] > 0){
	$result[^sBody.match[${hConst.hBracket.sBegin}(.+?)${hConst.hBracket.sEnd}\s*^$][]{^self._load[$match.1]}]
}{
	$result[$sBody]
}
#end @_cut[]



###########################################################################
@_load[sHeaders][hHeader;sKey;uValue]
$hHeader[^self._unpackHeaders[$sHeaders]]
^hHeader.foreach[sKey;uValue]{
	$response:[$sKey][$uValue]
}
$result[]
#end @_load[]



###########################################################################
@_packHeaders[hHeader][sKey;uValue]
$result[^hHeader.foreach[sKey;uValue]{^self._packItem[$sKey;$uValue]}[$hConst.hSeparator.sHeaders]]
#end @_packHeaders[]



###########################################################################
@_packItem[sName;uValue][sType;sKey;sValue;sVal]
^if(def $uValue){
	^if($uValue is "string"){
		$sType[string]
		$sValue[$uValue]
	}{
		^if($uValue is "int" || $uValue is "double"){
			$sType[number]
			$sValue[$uValue]
		}{
			^if($uValue is "date"){
				$sType[date]
				$sValue[^uValue.unix-timestamp[]]
			}{
				^if($uValue is "hash"){
					$sType[hash]
					$sValue[^uValue.foreach[sKey;sVal]{$sKey^#09$sVal}[^#0A]]
				}
			}
		}
	}
	$result[^if(def $sValue){${sName}${hConst.hSeparator.sFields}${sType}${hConst.hSeparator.sFields}$sValue}]
}{
	$result[]
}
#end @_packItem[]



###########################################################################
@_unpackHeaders[sHeaders][tHeader;hHeader]
$result[^hash::create[]]
$tHeader[^sHeaders.split[$hConst.hSeparator.sHeaders][lv]]
^tHeader.menu{
	$hHeader[^self._unpackItem[$tHeader.piece]]
	^if(def $hHeader.value){
		$result.[$hHeader.name][$hHeader.value]
	}
}
#end @_unpackHeaders[]



###########################################################################
@_unpackItem[sItem][tValue;sValue]
^if(def $sItem){
	^sItem.match[^^([^^$hConst.hSeparator.sFields]+)\${hConst.hSeparator.sFields}([^^$hConst.hSeparator.sFields]+)\${hConst.hSeparator.sFields}(.+)^$][]{
		$sValue[^taint[as-is][$match.3]]
		$result[
			$.name[$match.1]
			$.type[$match.2]
			^switch[$match.2]{
				^case[number]{
					$.value($sValue)
				}
				^case[date]{
					$.value[^date::unix-timestamp($sValue)]
				}
				^case[hash]{
					$tValue[^table::create{name^#09value^#0A$sValue}]
					^if($tValue){
						$.value[
							^tValue.menu{$.[$tValue.name][$tValue.value]}
						]
					}{
						$.value[^hash::create[]]
					}
				}
				^case[string]{
					$.value[$sValue]
				}
			}
		]
	}
}
^if(!def $result){
	$result[^hash::create[]]
}
#end @_unpackItem[]



###########################################################################
@_comments[sKey;iTime;bExecuted]
^if($bAddComments){
	^if($bExecuted){
		^if(-f "$sCacheDir/$sKey"){
			$result[^self._print[$sKey]($iTime)[Page was generated.]]]
		}{
			$result[^self._print[$sKey]($iTime)[Page was generated. Storing to cache skipped.]]]
		}
	}{
		$result[^self._print[$sKey]($iTime)[Page was taked from cache.]]]
	}
}{
	$result[]
}
#end @_comments[]



###########################################################################
@_print[sKey;iTime;sText]
$result[<!-- $sText Key: '$sKey', Time: '$iTime' secs -->]
#end @_print[]
